/*
Pronaci element (ako postoji) niza a kojemu
je suma znamenaka jednaka x.
*/

#include <stdio.h>

void ucitaj_niz(int a[], int n)
{
    int i;

    for(i=0; i<n; i++){
        printf("a[%d]= ", i);
        scanf("%d", &a[i]);
    }
}

void ispisi_niz(int a[], int n)
{
    int i;

    for(i=0; i<n; i++)
        printf("%d ", a[i]);
}

int suma_zn(int x)
{
    int suma=0;

    if(x<0) x=-x;

    while(x){
        suma+=x%10;
        x/=10;
    }

    return suma;
}

int kriterij(int x, int y)
{
    if(suma_zn(x)>suma_zn(y))
        return 1;
    return 0;
}

void sortiraj_niz(int a[], int n)
{
    int i, j, temp;

    for(i=0; i<n-1; i++){
        for(j=i+1; j<n; j++){
            if(!kriterij(a[i],a[j])){
                temp=a[i];
                a[i]=a[j];
                a[j]=temp;
            }
        }
    }
}

int trazi_bin(int a[], int n, int x)
{
    int l=0, d=n-1, s;

    while(l<=d){
        s=(d+l)/2;
        if(suma_zn(a[s])==x)
            return s;
        else if(suma_zn(a[s])<x)
            d=s-1;
        else l=s+1;
    }

    return -1;
}

int main(void)
{
    int a[1316], n, x;

    printf("Ucitajte n:");
    scanf("%d", &n);

    ucitaj_niz(a,n);
    sortiraj_niz(a,n);
    ispisi_niz(a,n);

    printf("\n x= ");
    scanf("%d", &x);

    printf("Broj sa zbrojem znamenaka %d", x);
    printf(" se nalazi na mjestu %d\n", trazi_bin(a,n,x));

    return 0;
}
